/* Name:      ssd1306.c
 * Project:   UF lampa
 * Author:    r13-project.ru
 * Creation   Date: 11-10-19
 *            ver: 0.2b
 */
 
#include	<avr/pgmspace.h>
#include "ssd1306.h"


#define myabs(n) ((n) < 0 ? -(n) : (n))
#define DISPLAY_I2C_ADDRESS					 0x78
// size
#define DISPLAY_LCDWIDTH                      128
#define DISPLAY_LCDHEIGHT                     64
#define DISPLAY_DEFAULT_SPACE                 5
// Commands
#define DISPLAY_SETCONTRAST                  0x81
#define DISPLAY_DISPLAYALLON_RESUME          0xA4
#define DISPLAY_DISPLAYALLON                 0xA5
#define DISPLAY_NORMALDISPLAY                0xA6
#define DISPLAY_INVERTDISPLAY                0xA7
#define DISPLAY_DISPLAYOFF                   0xAE
#define DISPLAY_DISPLAYON                    0xAF
#define DISPLAY_SETDISPLAYOFFSET             0xD3
#define DISPLAY_SETCOMPINS                   0xDA
#define DISPLAY_SETVCOMDETECT                0xDB
#define DISPLAY_SETDISPLAYCLOCKDIV           0xD5
#define DISPLAY_SETPRECHARGE                 0xD9
#define DISPLAY_SETMULTIPLEX                 0xA8
#define DISPLAY_SETLOWCOLUMN                 0x00
#define DISPLAY_SETHIGHCOLUMN                0x10
#define DISPLAY_SETSTARTLINE                 0x40
#define DISPLAY_MEMORYMODE                   0x20
#define DISPLAY_COLUMNADDR                   0x21
#define DISPLAY_PAGEADDR                     0x22
#define DISPLAY_COMSCANINC                   0xC0
#define DISPLAY_COMSCANDEC                   0xC8
#define DISPLAY_SEGREMAP                     0xA0
#define DISPLAY_CHARGEPUMP                   0x8D
#define DISPLAY_EXTERNALVCC                   0x1
#define DISPLAY_SWITCHCAPVCC                  0x2
// Scrolling #defines
#define DISPLAY_ACTIVATE_SCROLL               0x2F
#define DISPLAY_DEACTIVATE_SCROLL             0x2E
#define DISPLAY_SET_VERTICAL_SCROLL_AREA      0xA3
#define DISPLAY_RIGHT_HORIZONTAL_SCROLL       0x26
#define DISPLAY_LEFT_HORIZONTAL_SCROLL        0x27
#define DISPLAY_VERT_AND_RIGHT_HORIZ_SCROLL   0x29
#define DISPLAY_VERT_AND_LEFT_HORIZ_SCROLL    0x2A

#define COMAND		                          0x00
#define DATA		                          0x40
#define DISPLAY_OFF		                      LCD_Commmand(COMAND,DISPLAY_DISPLAYOFF)
#define DISPLAY_ON		                      LCD_Commmand(COMAND,DISPLAY_DISPLAYON)
#define NORMAL_DISPLAY                        LCD_Commmand(COMAND, DISPLAY_NORMALDISPLAY)
#define INVERT_DISPLAY                        LCD_Commmand(COMAND, DISPLAY_INVERTDISPLAY)
unsigned char LCD_X,LCD_Y;




/*
flash unsigned char image0[1026] =
{
0x00,0xFE,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0xFE,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,
0xFF,0x07,0x1E,0x38,0x60,0xC0,0x60,0x30,
0x1E,0x07,0xFF,0xFF,0x00,0x00,0xFF,0xFF,
0x83,0x83,0x83,0x83,0x83,0x83,0x83,0x00,
0x00,0xFC,0xFC,0x06,0x03,0x03,0x83,0x83,
0x83,0x8F,0x8E,0x00,0x00,0xF0,0xF8,0x8C,
0x84,0x86,0x83,0x83,0x83,0x86,0x8C,0x8C,
0xF8,0xF0,0x00,0x00,0x80,0x80,0x80,0x80,
0x80,0x80,0x00,0x00,0xF0,0xF8,0x9C,0x8C,
0x86,0x87,0x83,0x83,0x87,0x8E,0x9C,0xF8,
0xF0,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
0x00,0x00,0xFC,0xFE,0x83,0x83,0x83,0x83,
0x83,0x83,0x83,0xFE,0x3C,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,
0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xFF,0xFF,0x00,0x00,0xFF,0xFF,
0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0x00,
0x00,0x1F,0x3F,0x70,0xE0,0xC0,0xC1,0xE1,
0x31,0x3F,0x0F,0x00,0x00,0xFF,0xFF,0x01,
0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
0xFF,0xFF,0x00,0x00,0x01,0x01,0x01,0x01,
0x01,0x01,0x00,0x00,0xFF,0xFF,0x01,0x01,
0x01,0x01,0x01,0x01,0x01,0x01,0x01,0xFF,
0xFF,0x00,0x00,0x03,0x0F,0x18,0x30,0x60,
0xC0,0x80,0x80,0xC0,0x70,0x18,0x0F,0x03,
0x00,0x00,0xFF,0xFF,0x01,0x01,0x03,0x07,
0x0D,0x39,0x71,0xC0,0x80,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x80,0x80,0xC0,0xC0,0xC0,0xC0,0xC0,
0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x20,0x60,0xC0,0xC0,0x80,0x80,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,
0xC0,0xC0,0x20,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x80,0xE0,0xF8,0x3C,0x1E,
0x06,0x03,0xC1,0x61,0x20,0x20,0x60,0xC0,
0x00,0x00,0x00,0x80,0xC0,0x41,0x41,0xC1,
0x03,0x03,0x03,0x06,0x1C,0x18,0x38,0x70,
0xE0,0x80,0x00,0x00,0x00,0x00,0x00,0x01,
0x03,0x06,0x0C,0x18,0x30,0xE0,0xC0,0xC0,
0xC0,0xE0,0x30,0x18,0x0C,0x06,0x03,0x01,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x01,0x03,0x07,
0x0F,0x0E,0x1C,0x3C,0x78,0x78,0xF0,0xF0,
0xE0,0xC0,0xC0,0x80,0x80,0x00,0x00,0x00,
0x00,0x00,0x80,0x80,0xC0,0xE0,0xE0,0xF0,
0xF8,0xF8,0xFC,0xFC,0x7E,0x1F,0x0F,0x03,
0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xF8,0xFF,0x03,0x00,0x00,0x00,
0x80,0x87,0x8D,0x0C,0x09,0x0C,0x06,0x03,
0x00,0x00,0x1F,0x11,0x12,0x18,0x0C,0x87,
0x80,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,
0x7F,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,
0xFF,0xFF,0x03,0x03,0x03,0x03,0x03,0x03,
0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,
0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x81,
0xC3,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFE,
0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0xCF,0x87,0x83,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x0F,0x1F,0x7C,0xF8,0xC0,0x80,
0x81,0x87,0x8D,0x8B,0x0A,0x1A,0x16,0x14,
0x14,0x14,0x14,0x14,0x16,0x1B,0x0D,0x07,
0x81,0x80,0xC0,0xE0,0x78,0x3E,0x1F,0x07,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xFF,0xFF,0x80,0x80,0x80,0x80,0x80,0x80,
0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x80,0xC0,0xC0,0xE0,0xF0,0xF0,
0xF8,0xFC,0xFC,0xFE,0xFF,0xFF,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0xFF,0xBF,0x9F,0x8F,0x87,0x8F,0x9F,0xBF,
0xBF,0xFF,0xFF,0xFF,0xFF,0xFE,0xFE,0xFC,
0xFC,0xF8,0xF0,0xF0,0xE0,0xE0,0xC0,0xC0,
0x80,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
0x00,0x7F,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x41,
0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43,
0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43,
0x41,0x41,0x41,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
0x41,0x41,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00
};

*/

unsigned char PROGMEM LCD_Buffer[0x031B] =
{
      0x00, 0x00, 0x00, 0x00, 0x00, // sp
	  0x00, 0x00, 0x2f, 0x00, 0x00, // !
	  0x00, 0x07, 0x00, 0x07, 0x00, // "
	  0x14, 0x7f, 0x14, 0x7f, 0x14, // #
	  0x24, 0x2a, 0x7f, 0x2a, 0x12, // $
	  0x23, 0x13, 0x08, 0x64, 0x62, // %				

	  0x36, 0x49, 0x55, 0x22, 0x50, // &
	  0x00, 0x05, 0x03, 0x00, 0x00, // '
	  0x00, 0x1c, 0x22, 0x41, 0x00, // (
	  0x00, 0x41, 0x22, 0x1c, 0x00, // )
	  0x14, 0x08, 0x3E, 0x08, 0x14, // *
	  0x08, 0x08, 0x3E, 0x08, 0x08, // +
	  0x00, 0x00, 0x50, 0x30, 0x00, // ,
	  0x10, 0x10, 0x10, 0x10, 0x10, // -
	  0x00, 0x60, 0x60, 0x00, 0x00, // .
	  0x20, 0x10, 0x08, 0x04, 0x02, // /
	  0x3E, 0x51, 0x49, 0x45, 0x3E, // 0
	  0x00, 0x42, 0x7F, 0x40, 0x00, // 1
	  0x42, 0x61, 0x51, 0x49, 0x46, // 2
	  0x21, 0x41, 0x45, 0x4B, 0x31, // 3
	  0x18, 0x14, 0x12, 0x7F, 0x10, // 4
	  0x27, 0x45, 0x45, 0x45, 0x39, // 5
	  0x3C, 0x4A, 0x49, 0x49, 0x30, // 6
	  0x01, 0x71, 0x09, 0x05, 0x03, // 7
	  0x36, 0x49, 0x49, 0x49, 0x36, // 8
	  0x06, 0x49, 0x49, 0x29, 0x1E, // 9
	  0x00, 0x36, 0x36, 0x00, 0x00, // :
	  0x00, 0x56, 0x36, 0x00, 0x00, // ;
	  0x08, 0x14, 0x22, 0x41, 0x00, // <
	  0x14, 0x14, 0x14, 0x14, 0x14, // =
	  0x00, 0x41, 0x22, 0x14, 0x08, // >
	  0x02, 0x01, 0x51, 0x09, 0x06, // ?
	  0x32, 0x49, 0x59, 0x51, 0x3E, // @
	  0x7E, 0x11, 0x11, 0x11, 0x7E, // A
	  0x7F, 0x49, 0x49, 0x49, 0x36, // B
	  0x3E, 0x41, 0x41, 0x41, 0x22, // C
	  0x7F, 0x41, 0x41, 0x22, 0x1C, // D
	  0x7F, 0x49, 0x49, 0x49, 0x41, // E
	  0x7F, 0x09, 0x09, 0x09, 0x01, // F
	  0x3E, 0x41, 0x49, 0x49, 0x7A, // G
	  0x7F, 0x08, 0x08, 0x08, 0x7F, // H
	  0x00, 0x41, 0x7F, 0x41, 0x00, // I
	  0x20, 0x40, 0x41, 0x3F, 0x01, // J
	  0x7F, 0x08, 0x14, 0x22, 0x41, // K
	  0x7F, 0x40, 0x40, 0x40, 0x40, // L
	  0x7F, 0x02, 0x0C, 0x02, 0x7F, // M
	  0x7F, 0x04, 0x08, 0x10, 0x7F, // N
	  0x3E, 0x41, 0x41, 0x41, 0x3E, // O
	  0x7F, 0x09, 0x09, 0x09, 0x06, // P
	  0x3E, 0x41, 0x51, 0x21, 0x5E, // Q
	  0x7F, 0x09, 0x19, 0x29, 0x46, // R
	  0x46, 0x49, 0x49, 0x49, 0x31, // S
	  0x01, 0x01, 0x7F, 0x01, 0x01, // T
	  0x3F, 0x40, 0x40, 0x40, 0x3F, // U
	  0x1F, 0x20, 0x40, 0x20, 0x1F, // V
	  0x3F, 0x40, 0x38, 0x40, 0x3F, // W
	  0x63, 0x14, 0x08, 0x14, 0x63, // X
	  0x07, 0x08, 0x70, 0x08, 0x07, // Y
	  0x61, 0x51, 0x49, 0x45, 0x43, // Z
	  0x00, 0x7F, 0x41, 0x41, 0x00, // [
	  0x55, 0x2A, 0x55, 0x2A, 0x55, // 55
	  0x00, 0x41, 0x41, 0x7F, 0x00, // ]
	  0x04, 0x02, 0x01, 0x02, 0x04, // ^
	  0x40, 0x40, 0x40, 0x40, 0x40, // _
	  0x00, 0x01, 0x02, 0x04, 0x00, // '
	  0x20, 0x54, 0x54, 0x54, 0x78, // a
	  0x7F, 0x48, 0x44, 0x44, 0x38, // b
	  0x38, 0x44, 0x44, 0x44, 0x20, // c
	  0x38, 0x44, 0x44, 0x48, 0x7F, // d
	  0x38, 0x54, 0x54, 0x54, 0x18, // e
	  0x08, 0x7E, 0x09, 0x01, 0x02, // f
	  0x0C, 0x52, 0x52, 0x52, 0x3E, // g
	  0x7F, 0x08, 0x04, 0x04, 0x78, // h
	  0x00, 0x44, 0x7D, 0x40, 0x00, // i
	  0x20, 0x40, 0x44, 0x3D, 0x00, // j
	  0x7F, 0x10, 0x28, 0x44, 0x00, // k
	  0x00, 0x41, 0x7F, 0x40, 0x00, // l
	  0x7C, 0x04, 0x18, 0x04, 0x78, // m
	  0x7C, 0x08, 0x04, 0x04, 0x78, // n
	  0x38, 0x44, 0x44, 0x44, 0x38, // o
	  0x7C, 0x14, 0x14, 0x14, 0x08, // p
	  0x08, 0x14, 0x14, 0x18, 0x7C, // q
	  0x7C, 0x08, 0x04, 0x04, 0x08, // r
	  0x48, 0x54, 0x54, 0x54, 0x20, // s
	  0x04, 0x3F, 0x44, 0x40, 0x20, // t
	  0x3C, 0x40, 0x40, 0x20, 0x7C, // u
	  0x1C, 0x20, 0x40, 0x20, 0x1C, // v
	  0x3C, 0x40, 0x30, 0x40, 0x3C, // w
	  0x44, 0x28, 0x10, 0x28, 0x44, // x
	  0x0C, 0x50, 0x50, 0x50, 0x3C, // y
	  0x44, 0x64, 0x54, 0x4C, 0x44, // z

	  0x08, 0x08, 0x36, 0x41, 0x41, //  
	  0x00, 0x00, 0x7F, 0x00, 0x00, // |
	  0x41, 0x41, 0x36, 0x08, 0x08,  //  
	  0x02, 0x01, 0x02, 0x02, 0x01,  // ~
   
	  0x7E, 0x11, 0x11, 0x11, 0x7E, // 
	  0x7F, 0x49, 0x49, 0x49, 0x33, // 
	  0x7F, 0x49, 0x49, 0x49, 0x36, // 
	  0x7F, 0x01, 0x01, 0x01, 0x03, // 
	  0xE0, 0x51, 0x4F, 0x41, 0xFF, // 
	  0x7F, 0x49, 0x49, 0x49, 0x49, // 
	  0x77, 0x08, 0x7F, 0x08, 0x77, // 
	  0x49, 0x49, 0x49, 0x49, 0x36, // 
	  0x7F, 0x10, 0x08, 0x04, 0x7F, // 
	  0x7C, 0x21, 0x12, 0x09, 0x7C, // 
	  0x7F, 0x08, 0x14, 0x22, 0x41, // 
	  0x20, 0x41, 0x3F, 0x01, 0x7F, // 
	  0x7F, 0x02, 0x0C, 0x02, 0x7F, // 
	  0x7F, 0x08, 0x08, 0x08, 0x7F, // 
	  0x3E, 0x41, 0x41, 0x41, 0x3E, // 
	  0x7F, 0x01, 0x01, 0x01, 0x7F, // 
	  0x7F, 0x09, 0x09, 0x09, 0x06, // 
	  0x3E, 0x41, 0x41, 0x41, 0x22, // 
	  0x01, 0x01, 0x7F, 0x01, 0x01, // 
	  0x27, 0x48, 0x48, 0x48, 0x3F, // 
	  0x1C, 0x22, 0x7F, 0x22, 0x1C, // 
	  0x63, 0x14, 0x08, 0x14, 0x63, // 
	  0x7F, 0x40, 0x40, 0x40, 0xFF, // 
	  0x07, 0x08, 0x08, 0x08, 0x7F, // 
	  0x7F, 0x40, 0x7F, 0x40, 0x7F, // 
	  0x7F, 0x40, 0x7F, 0x40, 0xFF, // 
	  0x01, 0x7F, 0x48, 0x48, 0x30, // 
	  0x7F, 0x48, 0x30, 0x00, 0x7F, // 
	  0x7F, 0x48, 0x48, 0x30, 0x00, // 
	  0x22, 0x41, 0x49, 0x49, 0x3E, // 
	  0x7F, 0x08, 0x3E, 0x41, 0x3E, // 
	  0x46, 0x29, 0x19, 0x09, 0x7F, // 
	  0x20, 0x54, 0x54, 0x54, 0x78, // 
	  0x3C, 0x4A, 0x4A, 0x49, 0x31, // 
	  0x7C, 0x54, 0x54, 0x28, 0x00, // 
	  0x7C, 0x04, 0x04, 0x04, 0x0C, // 
	  0xE0, 0x54, 0x4C, 0x44, 0xFC, // 
	  0x38, 0x54, 0x54, 0x54, 0x08, // 
	  0x6C, 0x10, 0x7C, 0x10, 0x6C, // 
	  0x44, 0x44, 0x54, 0x54, 0x28, // 
	  0x7C, 0x20, 0x10, 0x08, 0x7C, // 
	  0x78, 0x42, 0x24, 0x12, 0x78, // 
	  0x7C, 0x10, 0x28, 0x44, 0x00, // 
	  0x20, 0x44, 0x3C, 0x04, 0x7C, // 
	  0x7C, 0x08, 0x10, 0x08, 0x7C, // 
	  0x7C, 0x10, 0x10, 0x10, 0x7C, // 
	  0x38, 0x44, 0x44, 0x44, 0x38, // 
	  0x7C, 0x04, 0x04, 0x04, 0x7C, // 
	  0x7C, 0x14, 0x14, 0x14, 0x08, // 
	  0x38, 0x44, 0x44, 0x44, 0x44, // 
	  0x04, 0x04, 0x7C, 0x04, 0x04, // 
	  0x0C, 0x50, 0x50, 0x50, 0x3C, // 
	  0x18, 0x24, 0x7E, 0x24, 0x18, // 
	  0x44, 0x28, 0x10, 0x28, 0x44, // 
	  0x7C, 0x40, 0x40, 0x40, 0xFC, // 
	  0x0C, 0x10, 0x10, 0x10, 0x7C, // 
	  0x7C, 0x40, 0x7C, 0x40, 0x7C, // 
	  0x7C, 0x40, 0x7C, 0x40, 0xFC, // 
	  0x04, 0x7C, 0x50, 0x50, 0x20, // 
	  0x7C, 0x50, 0x20, 0x00, 0x7C, // 
	  0x7C, 0x50, 0x50, 0x20, 0x00, // 
	  0x28, 0x44, 0x54, 0x54, 0x38, // 
	  0x7C, 0x10, 0x38, 0x44, 0x38, // 
	  0x08, 0x54, 0x34, 0x14, 0x7C  // 
};


/*
unsigned char PROGMEM BigNum[13][96] =
{ //0
{0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x01,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x80, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x03, 0x00, 0x00, 0x00},
 //1
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0xF0,
0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF,
0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x07, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
 //2
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0xC1, 0xC0, 0xC0, 0xC0,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
0x03, 0x03, 0x83, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
   //3
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0xC1, 0xC0, 0xC0, 0xC0,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0x7F, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x81, 0x83, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
  //4
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE0, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07,
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
  //5
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0x81, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x81, 0x83, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
 //6
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0x81, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
  //7
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
  //8
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xE1,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0x3F, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
    //9
{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07,
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
  //:    10
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x7E, 0x7E, 0x7E, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xF8, 0xF8, 0xF8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
  // .   11
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
 //    12
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x11, 0x11, 0x11, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}

};*/

void LCD_init(void) // ,            .
{
  DISPLAY_OFF;
  _delay_ms(10);
  LCD_Commmand(COMAND, DISPLAY_SETDISPLAYCLOCKDIV);
  LCD_Commmand(COMAND, 0x80);
  LCD_Commmand(COMAND, DISPLAY_SETMULTIPLEX);
  LCD_Commmand(COMAND, 0x3F);
  LCD_Commmand(COMAND, DISPLAY_SETDISPLAYOFFSET);
  LCD_Commmand(COMAND, 0x00);
  LCD_Commmand(COMAND, DISPLAY_SETSTARTLINE | 0x00);
    // We use internal charge pump
  LCD_Commmand(COMAND, DISPLAY_CHARGEPUMP);
  LCD_Commmand(COMAND, 0x14);
    // Horizontal memory mode
  LCD_Commmand(COMAND, DISPLAY_MEMORYMODE);
  LCD_Commmand(COMAND, 0x00);
  LCD_Commmand(COMAND, DISPLAY_SEGREMAP | 0x1);
  LCD_Commmand(COMAND, DISPLAY_COMSCANDEC);
  LCD_Commmand(COMAND, DISPLAY_SETCOMPINS);
  LCD_Commmand(COMAND, 0x12);
    // Max contrast
  LCD_Commmand(COMAND, DISPLAY_SETCONTRAST);
  LCD_Commmand(COMAND, 0xCF);
  LCD_Commmand(COMAND, DISPLAY_SETPRECHARGE);
  LCD_Commmand(COMAND, 0xF1);
  LCD_Commmand(COMAND, DISPLAY_SETVCOMDETECT);
  LCD_Commmand(COMAND, 0x40);
  LCD_Commmand(COMAND, DISPLAY_DISPLAYALLON_RESUME);

  NORMAL_DISPLAY;     //  
  DISPLAY_ON;
  LCD_Clear();
}

void LCD_Commmand(unsigned char ControByte, unsigned char DataByte)
{
  I2C_Start();   //   
  I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
  I2C_SendByte(ControByte);
  I2C_SendByte(DataByte);
  I2C_Stop();
}


void LCD_Clear(void)
{   //      ,              ,    
	unsigned short i;
	LCD_Goto(0,0);
    I2C_Start();   //   
    I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
    I2C_SendByte(DATA);//data mode
	for (i=0; i<(DISPLAY_LCDWIDTH*DISPLAY_LCDHEIGHT/8)+10; i++) //(DISPLAY_LCDWIDTH*DISPLAY_LCDHEIGHT/8)
	{
        I2C_SendByte(0x00);
	}     
    
    I2C_Stop();    //    i2c
	LCD_X = 0;
	LCD_Y = 0;
	LCD_Goto(0,0);
}


void LCD_Goto(unsigned char x, unsigned char y)
{
	//    
	LCD_Commmand(COMAND, 0xB0 + y);//   
	LCD_Commmand(COMAND, x & 0xf);//   
	LCD_Commmand(COMAND,0x10 | (x >> 4));//   
	LCD_X = x;
	LCD_Y = y;
}



void LCD_Contrast(char set_contrast)
{
  LCD_Commmand(COMAND, DISPLAY_DISPLAYOFF);
 _delay_ms(10);
  LCD_Commmand(COMAND, DISPLAY_SETCONTRAST);
  LCD_Commmand(COMAND, set_contrast);
  LCD_Commmand(COMAND, DISPLAY_DISPLAYON);
}



unsigned char LCD_symbol_decode(unsigned char c)
{
	if(32<=c&&c<='~')
	{
		c=c-32;
	}
	else
	{
		if(192<=c&&c<=255)
		{
			c=c-97;
		}
		else
		{
			c=250;
		}
	}
	return c;
}

void LCD_Char(unsigned char c, unsigned char inverse) //   
{
  unsigned char x = 0;
  c=LCD_symbol_decode(c);  //      
  if(c==250)               //     ,     
	{
		return;
	}
  if(LCD_X+5>DISPLAY_LCDWIDTH) //   ,    
	{
		LCD_X = 0;
		LCD_Y++;
		LCD_Goto(LCD_X,LCD_Y);
	}
 //  	
  I2C_Start();   //   
  I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
  I2C_SendByte(DATA);//data mode
  for (x=0; x<5; x++)
	{
		if (inverse==0)
		{
        I2C_SendByte(pgm_read_byte(LCD_Buffer+(c*5+x)));//      
		}
		else
		{
		I2C_SendByte(~(pgm_read_byte(LCD_Buffer+(c*5+x))));
		}
     }
	 if (inverse==0)
		{
        I2C_SendByte(0x00);  //     
        }
		else
		{
		I2C_SendByte(0xFF);
		}
  
  I2C_Stop();    //    i2c

	LCD_X += 6;
	
}
 
void LCD_CharBig(unsigned int c, unsigned char inverse) //     
{
unsigned char x = 0;
unsigned char s = 0;
  c=LCD_symbol_decode(c);  //      
  if(c==250)               //     ,     
	{
		return;
	}
  if(LCD_X+10>DISPLAY_LCDWIDTH) //   ,    
	{
		LCD_X = 0;
		LCD_Y++;
		LCD_Goto(LCD_X,LCD_Y);
	}
 //  	
  I2C_Start();   //   
  I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
  I2C_SendByte(DATA);//data mode
  for (x=0; x<5; x++)
	{   s=pgm_read_byte(LCD_Buffer+(c*5+x));
		if (inverse==0)
		{
        I2C_SendByte(s);//      
		if (c!=' ') I2C_SendByte(s);
		}
		else
		{
		I2C_SendByte(~(s));
		if (c!=' ') I2C_SendByte(~(s));
		}
     }
	 if (inverse==0)
		{
        I2C_SendByte(0x00);  //     
        }
		else
		{
		I2C_SendByte(0xFF);
		}
  
  I2C_Stop();    //    i2c

	//LCD_X += 6;
  if (c!=' ') LCD_X += 11; else LCD_X += 6;
	 
}
 
 /* ===================================================>>>>>>>>>>>>>      ,  ,   1,5 
void LCD_BigNum(unsigned char num)
{
  unsigned char x = 0;
  unsigned char z = 0;

  unsigned char y_s = LCD_Y;

  if(num!=46&&num!=32&&num!=67){num = num - 48;}
  else
   {
   if(num==46){ num = 12; }  // .12
   if(num==67){ num = 13; }  // 13    
   }

  I2C_Start();   //   
  I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
  I2C_SendByte(DATA);//data mode
  for (x=0; x<96; x++)
	{
     I2C_SendByte(BigNum[num][x]);
     if(z>=23)
     {
       I2C_Stop();    //    i2c
       LCD_Goto(LCD_X,LCD_Y+1);

       z=0;
       I2C_Start();   //   
       I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
       I2C_SendByte(DATA);//data mode
     }else{z++;}

     }
  I2C_Stop();    //    i2c

	LCD_X += 23;
    LCD_Goto(LCD_X,y_s);
    if(LCD_X>DISPLAY_LCDWIDTH)
	{
		LCD_X = 0;
	}
} 
 
 */
 
 
 
void LCD_Printf(unsigned char *buf, unsigned char size, unsigned char inverse) //   
 {

	while (*buf!=0)
	{
       if(size==0) LCD_Char(*buf++, inverse);
       if(size==1) LCD_CharBig(*buf++, inverse);
     //  if(size==2) LCD_BigNum(*buf++);  
	}
 }




void LCD_Dot(char x, char y)
{
char dot;
if ((y<=63)&&(x<=127))
  {
  dot=y%8;
  y=y/8;//   8 ,     .    ,    
  LCD_Goto(x,y);
  y=0x01;
  y=y<<dot;
  LCD_Konnekt();
  I2C_SendByte(y);
  I2C_Stop();
  }
}

void LCD_Konnekt(void)
{
//  -      NACK
I2C_Start();   //   
I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
I2C_SendByte(DATA);//data mode
}




void LCD_Lines( unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2)
{  
    const int deltaX = myabs(x2 - x1);
    const int deltaY = myabs(y2 - y1);
    const int signX = x1 < x2 ? 1 : -1;
    const int signY = y1 < y2 ? 1 : -1;
    int error = deltaX - deltaY;
	
	char send=0x00;
	char x=x1;
	//char y=y1;
    LCD_Dot(x2,y2);
	LCD_Goto(x1,y1/8);
	
    while(x1 != x2 || y1 != y2)
    {
        	
		if(x==x1&&y1%8!=0&&y1 != y2-1)
		{
		send|=1<<y1%8;
		}
		else
		{
		
  		LCD_Konnekt();
        I2C_SendByte(send);
        I2C_Stop();		
		LCD_Goto(x1,y1/8);
		x=x1;
		send=0x00;
		send|=1<<y1%8;
		
		}
		
        const int error2 = error * 2;
        if(error2 > -deltaY)
        {
            error -= deltaY;
            x1 += signX;
        }
        if(error2 < deltaX)
        {
            error += deltaX;
            y1 += signY;
        }
    }

}




void LCD_Goto2X(unsigned char x, unsigned char y)
{
	LCD_X = x;
	LCD_Y = y;

	//    
	LCD_Commmand(COMAND, 0xB0 + y);//   
	LCD_Commmand(COMAND, 2*x & 0xf);//   
	LCD_Commmand(COMAND,0x10 | (2*x >> 4));//   
}



/*
void LCD_CharBig(unsigned int c)
{
  unsigned char x = 0;
  unsigned int m = 0;

  I2C_Start();   //   
  I2C_SendByte(DISPLAY_I2C_ADDRESS);   //    
  I2C_SendByte(DATA);//data mode
  for (x=0; x<5; x++)
	{
     m = LCD_Buffer[c*5+x];
     I2C_SendByte(m);
     I2C_SendByte(m);
     }
  I2C_SendByte(0x00);  //     
  I2C_Stop();    //    i2c
	LCD_X += 11;
	if(LCD_X>DISPLAY_LCDWIDTH)
	{
		LCD_X = DISPLAY_DEFAULT_SPACE;
	}
}
*/



/*
void LCD_DrawImage(unsigned char num_image)
{
	unsigned int i;
	unsigned char x=0;
	unsigned char y=0;
	LCD_Goto(0,0);

	for (i=0; i<(DISPLAY_LCDWIDTH*DISPLAY_LCDHEIGHT/8); i++)
	{
        if(num_image==0)
        {
		LCD_Commmand(DATA, image0[i]);
        }

		x++;
		if(x>=DISPLAY_LCDWIDTH)
		{
			x=0;
			y++;
			LCD_Goto(0,y);
		}
	}
}

void LCD_Bat(unsigned char y,unsigned char x, unsigned char z)
{
 unsigned char i=0;

 LCD_Goto2X(x-1,y);
 LCD_Commmand(DATA, 0xFF); LCD_Commmand(DATA, 0xFF);
 LCD_Goto2X(x+2,y);
for (i=0; i<14; i++)
	{
       if(i<11)
       {
         if(z>=i){ LCD_Commmand(DATA, 0xBD); }
         else    { LCD_Commmand(DATA, 0x81); LCD_Commmand(DATA, 0x81); }
       }
       if(i==11)      {LCD_Commmand(DATA, 0xFF); LCD_Commmand(DATA, 0xFF);}
       if(i==12)      {LCD_Commmand(DATA, 0x3C); LCD_Commmand(DATA, 0x3C);}
       if(i==13)      {LCD_Commmand(DATA, 0x3C); LCD_Commmand(DATA, 0x3C);}
       LCD_Goto2X(x+i,y);
	}

}


  */


